package com.mortals.xhx.module.customer.web;
import com.mortals.framework.common.IBaseEnum;
import com.mortals.framework.exception.AppException;
import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.common.code.DesignTypeEnum;
import com.mortals.xhx.common.key.Constant;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;
import com.mortals.framework.model.Context;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.module.customer.model.CustomerWorkCollectEntity;
import com.mortals.xhx.module.customer.model.CustomerWorkCollectQuery;
import com.mortals.xhx.module.customer.service.CustomerWorkCollectService;
import org.apache.commons.lang3.ArrayUtils;
import com.mortals.framework.util.StringUtils;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import com.alibaba.fastjson.JSONObject;
import java.util.Arrays;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;
import static com.mortals.framework.ap.SysConstains.*;
/**
*
* 客户收藏信息
*
* @author zxfei
* @date 2022-06-13
*/
@RestController
@RequestMapping("customer/work/collect")
public class CustomerWorkCollectController extends BaseCRUDJsonBodyMappingController<CustomerWorkCollectService,CustomerWorkCollectEntity,Long> {

    public CustomerWorkCollectController(){
        super.setModuleDesc( "客户收藏信息");
    }

    @Override
    protected void init(Map<String, Object> model, Context context) {
        this.addDict(model, "designType", IBaseEnum.getEnumMap(DesignTypeEnum.class));
        super.init(model, context);
    }

    @Override
    protected void doListBefore(CustomerWorkCollectEntity query, Map<String, Object> model, Context context) throws AppException {
        if(this.getCurUser()==null||this.getCurUser().getUserType()!= Constant.CUSTOMER_USER){
            throw new AppException("非法用户,不可访问");
        }
        query.setCustomerId(this.getCurUser().getId());
        Map<String,String> orderCols = new HashMap<>();
        orderCols.put("createTime","DESC");
        query.setOrderCols(orderCols);
    }

    @RequestMapping(value = {"delete/masterplateId"},method = {RequestMethod.POST, RequestMethod.GET})
    public String deleteByMasterplateId(Long id) {
        Context context = this.getContext();
        if (id == null) {
            return this.createFailJsonResp("请至少选择一条记录");
        } else {
            Map<String, Object> model = new HashMap();
            int code = 1;
            String busiDesc = "删除" + this.getModuleDesc();
            try {
                int iRet = this.service.removeByMasterplateId(id, context);
                model.put("message_info", this.getModuleDesc() + "删除成功!删除条数:" + iRet);
                this.recordSysLog(this.request, busiDesc + " 【成功】 [id:" + id + "]");
            } catch (Exception var7) {
                code = -1;
                this.doException(this.request, busiDesc, model, var7);
            }

            JSONObject ret = new JSONObject();
            ret.put("code", Integer.valueOf(code));
            ret.put("msg", model.remove("message_info"));
            ret.put("data", model);
            return ret.toJSONString();
        }
    }

}